// I took half this extension's code from https://extensions.gnome.org/accounts/profile/danigm 's extension "calc".
// Huge credits towards him/her.

const St = imports.gi.St;
const Main = imports.ui.main;

const Util = imports.misc.util;

const RunDialog = imports.ui.runDialog;
const Lang = imports.lang;

let basef = RunDialog._run;

function init() {	}

function enable()
{
    if (Main.runDialog == null)
        Main.runDialog = new RunDialog.RunDialog();
	
    let r = Main.runDialog;
    basef = Lang.bind(r, r._run);
	
    function processInput(input, inTerminal)
	{
        this._commandError = false;
        let value = "";
        let command = input;
        
        if (input.match(/[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/))
        {
            try 
			{
                output = Util.trySpawnCommandLine("xdg-open mailto://" + input);
                
            } catch (e)
			{
                this._showError(String(e.message));
            }

		// Credits go to https://extensions.gnome.org/accounts/profile/danigm for the calculation part
        } else if (input.match(/([\d\+\-\*\/\(\) \.]+)$/))
        {
            try
			{
                value = String(eval(input.substr(0)));
			
            } catch (e)
			{
                value = String(e.message);
            }
			
            this._entryText.set_text(value);
            
            let clipboard = St.Clipboard.get_default();
            clipboard.set_text(St.ClipboardType.CLIPBOARD, value);
            
            this._showError("Answer: " + String(value));
            
        } else if (input.match(/([a-z0-9_-]+\.)+[a-z]{2,4}[^ ]*$/))
        {
            try
			{
                Util.trySpawnCommandLine("xdg-open http://" + input);
                
            } catch (e)
			{
                this._showError(String(e.message));
            }

        } else if (input.substr(0, 6) == "define")
        {
            try
            {
                if (input.substr(0, 7) == "define:")
                    value = String(input.substr(7, input.length));
                else    
                    value = String(input.substr(6, input.length));
                
                let tmp0 = value.split(" ");
                let tmp = "";
                let i = 0;
                let started = false;
                
                for(i = 0; i < tmp0.length; i++)
                {
                    if (started)
					{
                        tmp += "+" + tmp0[i];
                        
                    } else {
                        
                        tmp += tmp0[i];
                        started = true;
                    }
                }
                
                Util.trySpawnCommandLine("xdg-open https://google.com/search?q=define:" + tmp);
                
            } catch(e)
            {
                value = String(e.message);
            }
			
        } else if (input.charAt(0) == "?" || input.slice(-1) == "?" || input.substr(0, 6) == "search")
		{
            try
            {
                if (input.charAt(0) == "?")
                    value = String(input.substr(1));
                else if(input.slice(-1) == "?")
                    value = String(input.substr(0, input.length -1));
                else
                    value = String(input.substr(6, input.length));
                
                let tmp0 = value.split(" ");
                let tmp = "";
                let i = 0;
                let started = false;
                
                for(i = 0; i < tmp0.length; i++)
                {
                    if (started)
					{
                        tmp += "+" + tmp0[i];
                        
                    } else {
                        
                        tmp += tmp0[i];
                        started = true;
                    }
                }
                
                Util.trySpawnCommandLine("xdg-open https://google.com/search?q=" + tmp);
                
            } catch(e)
            {
                value = String(e.message);
            }
        
        } else {
            
            basef(input, inTerminal);
        }
    }
    
    r._run = Lang.bind(r, processInput);
}

function disable()
{
    if (Main.runDialog == null)
        Main.runDialog = new RunDialog.RunDialog();
    
    let r = Main.runDialog;

    r._run = basef;
}
